using System;

namespace Atoms
{
    // All functions definitions
    
    public class Uplus : Function
    {
        public Uplus()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return args[0];
        }
    }

    public class Uminus : Function
    {
        public Uminus()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return -args[0];
        }
    }

    public class Plus : Function
    {
        public Plus()
        {
            Arity = 2;
        }

        public override double Eval(params double[] args)
        {
            return args[0] + args[1];
        }
    }

    public class Minus : Function
    {
        public Minus()
        {
            Arity = 2;
        }

        public override double Eval(params double[] args)
        {
            return args[0] - args[1];
        }
    }

    public class Mult : Function
    {
        public Mult()
        {
            Arity = 2;
        }

        public override double Eval(params double[] args)
        {
            return args[0] * args[1];
        }
    }

    public class Div : Function
    {
        public Div()
        {
            Arity = 2;
        }

        public override double Eval(params double[] args)
        {
            return args[0] / args[1];
        }
    }

    public class Pow : Function
    {
        public Pow()
        {
            Arity = 2;
        }

        public override double Eval(params double[] args)
        {
            return Math.Pow(args[0], args[1]);
        }
    }

    public class Exp : Function
    {
        public Exp()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Exp(args[0]);
        }
    }

    public class Log : Function
    {
        public Log()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Log(args[0]);
        }
    }

    public class Sqrt : Function
    {
        public Sqrt()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Sqrt(args[0]);
        }
    }

    public class Cos : Function
    {
        public Cos()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Cos(args[0]);
        }
    }

    public class Sin : Function
    {
        public Sin()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Sin(args[0]);
        }
    }

    public class Tan : Function
    {
        public Tan()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Tan(args[0]);
        }
    }

    public class Acos : Function
    {
        public Acos()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Acos(args[0]);
        }
    }

    public class Asin : Function
    {
        public Asin()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Asin(args[0]);
        }
    }

    public class Atan : Function
    {
        public Atan()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Atan(args[0]);
        }
    }

    public class Cosh : Function
    {
        public Cosh()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Cosh(args[0]);
        }
    }

    public class Sinh : Function
    {
        public Sinh()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Sinh(args[0]);
        }
    }

    public class Tanh : Function
    {
        public Tanh()
        {
            Arity = 1;
        }

        public override double Eval(params double[] args)
        {
            return Math.Tanh(args[0]);
        }
    }
	
}
