﻿using System;

using NExpression;

namespace EvalExpression
{
    class MainEntry
    {
        public static void Main(string[] args)
        {
            var exp = new Expression("(2+x) * 0.5*a^3 - (2*u) / (x-y)");
            Console.WriteLine("Parsed expression: " + exp);
            double resAt11 = exp.Eval(2.0, 1.0, 1.0, -1.0);
            Console.WriteLine("\nEval at 2,1,1,-1; should get 11: " + resAt11);
            Expression dexp = exp.Diff('x'); // should yield 0.5*a^3 + (2*u) / (x-y)^2
            Console.WriteLine("\nDiff. expected: 0.5*a^3 + (2*u) / (x-y)^2");
            Console.WriteLine("\nGot:\n" + dexp);
            Console.ReadLine();
        }
    }
}
